/*
	nIwT
	fjTvP
	}bvRg[
*/

#include	"stdafx.h"
#include	"ohx5_1.h"

//	`f[^(̂ݓ)
long	sdata[]={
	SIMPLE_CUBE,	2000,	4000,	2000,
	FILE_DATA,		1, 150000,
	FILE_DATA,		2, 150000,
	FILE_DATA,		3, 150000,
	FILE_DATA,		4, 150000,
	FILE_DATA,		5, 150000,
	FILE_DATA,		6, 150000,
	FILE_DATA,		7, 150000,
	FILE_DATA,		8, 150000,
	FILE_DATA,		9, 150000,
	SIMPLE_TORUS,	100,	150,
	SHAPE_DONE
};
//	}bv(̂ݓj
long	mapdata[]={
	2, -60000,-2000,  60000,   0,0,0,
	3, -60000,-2000, 120000,   0,0,0,
	4,-120000,-2000, 180000,   0,0,0,
	5,-120000,-2000, 120000,   0,0,0,
	6,-120000,-2000,  60000,   0,0,0,
	7, 240000,-2000,-180000,   0,0,0,
	8,-180000,-2000,-180000,   0,0,0,
	9,-180000,-2000,-180000,   0,0,0,
	10,180000,-2000,-120000,   0,0,0,
	10,180000,-2000, -60000,   0,0,0,
	0
};

//	Փˁ^CxgGA
//	0f[^I[
//	1Փ˔
//	2Cxg(Cxg̋N)
//	3rgCN(zzς݃f[^̎Q)
//	4[JN(}bv̕ʋԂƐڑ)
//	5^N(T[o[ʃ}bvƐڑ)
//	6nCp[N(ʃT[o[ʃ}bvƐڑ) Ή
long	areas[]={
	1, 
	3,
	0
};

char	*file_datanames[]={
	"data\\B01_F.x",
	"data\\B02_F.x",
	"data\\B03_F.x",
	"data\\b04_F.x",
	"data\\b05_F.x",
	"data\\b06_F.x",
	"data\\b07_F.x",
	"data\\b07_F.x",
	"data\\b07_F.x"
};

void	splitpath( char* fpath,char* fname )
{
char	*fp,*fn,*fpx;
	fp = fpath;
	fn = fname;
	fpx = NULL;
	while( *fn!=0 ){
		if( *fn=='\\' ) fpx = fp;
		*fp++ = *fn++;
	}
	*fp = 0;
	if( fpx!=NULL ){
		fpx++;
		*fpx = 0;
	}
}
/*
	`̏
	͓f[^𗘗p
*/

void	init_shapes()
{
HRESULT hr;
int	sct,name,i;
float	v1,v2,v3;
shapes*	spt = shapelist;
char	xfilepath[1024];
char	*xfilename;
	sct = 0;
	max_shapes = 0;
	while( sdata[sct]!=SHAPE_DONE ){
		name = sdata[sct++];
		spt->type = name;
		spt->scale= 1;
		switch( name ){
		case SIMPLE_CUBE:		//	
			v1 = (float)sdata[sct++]/1000;	//	witdh
			v2 = (float)sdata[sct++]/1000;	//	height
			v3 = (float)sdata[sct++]/1000;	//	depth 
			hr = D3DXCreateBox( lpD3DD,v1,v2,v3,&(spt->pt),NULL );
			break;
		case SIMPLE_SPHERE:		//	
			v1 = (float)sdata[sct++]/1000;	// radius
			hr = D3DXCreateSphere( lpD3DD,v1,D3DX_DEFAULT,D3DX_DEFAULT, &(spt->pt),NULL );
			break;
		case SIMPLE_CYLINDER:	//	V_[
			v1 = (float)sdata[sct++]/1000;	//	base radius
			v2 = (float)sdata[sct++]/1000;	//	top radius
			v3 = (float)sdata[sct++]/1000;	//	height
			hr = D3DXCreateCylinder( lpD3DD,v1,v2,v3,D3DX_DEFAULT,D3DX_DEFAULT,&(spt->pt),NULL );
			break;
		case SIMPLE_TORUS:		//	g[X
			v1 = (float)sdata[sct++]/1000;	//	inner radius
			v2 = (float)sdata[sct++]/1000;	//	outer radius
			hr = D3DXCreateTorus( lpD3DD,v1,v2,D3DX_DEFAULT,D3DX_DEFAULT,&(spt->pt),NULL );
			break;
		case FILE_DATA:			//	X-flie`̃[h
			LPD3DXBUFFER		xbuf;	//	wehkd}eAobt@
			xfilename = file_datanames[ sdata[sct++] ];
			if( xfilename==NULL ) { sct++; break; }
			if( FAILED( D3DXLoadMeshFromX(	xfilename,
								D3DXMESH_SYSTEMMEM,
								lpD3DD,
								NULL,
								&xbuf,
								&( spt->mats ),
								&( spt->pt ) ) ) ){
				sct++;
				break;
			}
			D3DXMATERIAL* lpxmats = (D3DXMATERIAL*)xbuf->GetBufferPointer();

			spt->lpmmats = new D3DMATERIAL8[spt->mats];
			spt->lpmtexs = new LPDIRECT3DTEXTURE8[spt->mats];

			for( i=0; i<(int)(spt->mats); i++ ){
				spt->lpmmats[i] = lpxmats[i].MatD3D;
				spt->lpmmats[i].Ambient = spt->lpmmats[i].Diffuse;
				// eNX`쐬B
				splitpath( xfilepath,xfilename );
				if( lpxmats[i].pTextureFilename != NULL ){
					strcat( xfilepath,lpxmats[i].pTextureFilename );
					if( FAILED( D3DXCreateTextureFromFile(	lpD3DD, 
															xfilepath, 
															&( spt->lpmtexs[i] ) ) ) )
						spt->lpmtexs[i] = NULL;
				}
			}
			spt->scale = (float)( sdata[ sct++ ] )/1000;
			xbuf->Release();
			break;
		}
		spt++;
		max_shapes++;
	}
}

//	`f[^
void	release_shapes()
{
DWORD	i,j;
shapes	* spt = shapelist;
	for( i=0;i<max_shapes;i++ ){
		if( spt->type==FILE_DATA ){
			if( spt->lpmmats != NULL )  delete[] spt->lpmmats;
			if( spt->lpmtexs ) {
				for( j = 0; j < spt->mats; j++ ) {
					if( spt->lpmtexs[j] ){ spt->lpmtexs[j]->Release(); }
				}
				delete[] spt->lpmtexs;
			}
		}
		xRelease( spt->pt );
		spt++;
	}
}

//	̃obt@1m
OBJ3D	*make_object( DWORD name )
{
OBJ3D *obj;
	obj = new OBJ3D;
	obj->back = NULL;
	obj->next = objtop;
	if( objtop!=NULL ) objtop->back = obj;
	objtop = obj;
	obj->type = name;
	return obj;
}

//	̃obt@1
void	delete_object( OBJ3D *obj )
{
	if( obj==NULL ) return;
	if( objtop == obj ) objtop = objtop->next;
	if( obj->back != NULL ) obj->back->next = obj->next;
	if( obj->next != NULL )	obj->next->back = obj->back;
	xDelete( obj );
}

//	}bv畨̃Xg
void	init_objects()
{
long	name;
int	ct=0;
OBJ3D	*obj;
	for(;;){
		name = mapdata[ ct++ ];
		if( name==0 ) break;
		obj = make_object( name-1 );
		obj->pos.x = (float)mapdata[ct++]/1000;
		obj->pos.y = (float)mapdata[ct++]/1000;
		obj->pos.z = (float)mapdata[ct++]/1000;
		obj->rudder.x = D3DXToRadian( mapdata[ct++] );
		obj->rudder.y = D3DXToRadian( mapdata[ct++] );
		obj->rudder.z = D3DXToRadian( mapdata[ct++] );
	}
}

void	release_objects()
{
OBJ3D	*obj = objtop;
OBJ3D	*nx;
	while( obj !=NULL ){
		nx = obj->next;
		delete_object( obj );
		obj = nx;
	}
}

//	vC[Xe[^X
void	init_player()
{
	make_myself();
	D3DXVECTOR3	zero;
	zero.x = zero.y = zero.z = 0;
	myself->objp->pos  = myself->objp->rudder =
	myself->objp->move = myself->objp->rotate = zero;
	myself->objp->rudder.y = D3DXToRadian( 45 );
}
//	vC[ɂ鐧
void	player_drive()
{
WORD	key = GetKeys();
	command_player( myself->objp,( key << 16 )| dpmsg_data_packet );
	send_player_control( myself->dplayID, key );

	camera_pos = myself->objp->pos;
	camera_rud = myself->objp->rudder;
}


//	vC[̋
//	vC[Ή
void	command_player( OBJ3D *ob,DWORD cmd )
{
WORD	key = (WORD)( cmd>>16 );

	if( key & PAD_CMD ){
//	Eɕsړ
//	㉺ɕsړ

	} else {
//	Eɐ
		if( key & PAD_LEFT ){
			if( ob->rotate.y<0.05f ) ob->rotate.y += 0.002f;
		} else if( key & PAD_RIGHT ){
			if( ob->rotate.y>-0.05f ) ob->rotate.y -= 0.002f;
		} else {
			if( ob->rotate.y>0.002f ) ob->rotate.y *= 0.8f; else ob->rotate.y = 0;
		}
//	㉺ɐiő㉺30xB񂵂ĂȂƂ́AIɐɖ߂j
		if( key & PAD_UP ){
			if( ob->rotate.x<0.05f ) ob->rotate.x += 0.002f;
		} else if( key & PAD_DOWN ){
			if( ob->rotate.x>-0.05f ) ob->rotate.x -= 0.002f;
		} else {
			ob->rotate.x = 0;
		}
	}
//	Oi
	if( key & PAD_FORWARD ){
		if( ob->move.z<1 ){
			ob->move.z += 0.002f;
		} else {
			ob->move.z = 1;
		}
	} else {
			if( ob->move.z>0.002f ) ob->move.z *= 0.8f; else ob->move.z = 0;
	}
//	xNgZ
	ob->rudder.y += ob->rotate.y;
	if( ob->rotate.x!=0 ){
		ob->rudder.x += ob->rotate.x;
		if( ob->rotate.x<0 ){
			if( ob->rudder.x<-0.7f ) ob->rudder.x = -0.7f;
		} else {
			if( ob->rudder.x> 0.7f ) ob->rudder.x = 0.7f;
		}
	} else {
		ob->rudder.x *= 0.8f;
		if( ob->rudder.x<0.01f && ob->rudder.x>-0.01f ){ ob->rudder.x = 0; }
	}
//	ړxNg
	D3DXMATRIX	mat;
	D3DXMatrixRotationY( &mat,-ob->rudder.y );
	D3DXVECTOR3	mv;
	mv = ob->move;
	D3DXVec3TransformNormal( &mv,&mv,&mat );
	ob->pos += mv;
}
